/*
DateTimeUtils.h
*/

#ifndef __DATETIME_UTILS_H
#define __DATETIME_UTILS_H

#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <limits.h>
#include <stdio.h>
#include <time.h>
#include <unistd.h>
#include <pwd.h>
#include <malloc.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <ctype.h>
#include <syslog.h>
#include <dirent.h>
#include <sys/times.h>                                             
#include <signal.h>

#define NUMBER_MONTHS      12
#define NUMBER_DAYSFORWEEK 7
#define HOURS_INTERVALS    15
#define BEGIN_HOUR_PLAN    7
#define MIN_YEAR           1900
#define MAX_YEAR           2100

typedef struct
  {
  int year, month, day;
  } TRecDate;
       
typedef TRecDate TMatWeek[NUMBER_DAYSFORWEEK];

int CurrentYear (void);
int CurrentMonth (void);
int CurrentDay (void);
int CurrentWeek (void);
bool DateIsToday (int day, int month, int year);
bool IsCorrectDay (int day, int month, int year);
void NextDay (int *day, int *month, int *year);
void PrevDay (int *day, int *month, int *year);
void NextMonth (int *month, int *year);
void PrevMonth (int *month, int *year);
void NextYear (int *year);
void PrevYear (int *year);
void NextWeek (int *initday, int *week, int *month, int *year);
void PrevWeek (int *initday, int *week, int *month, int *year);
int NumWeeksYear (int year);
int NumDaysYear (int year);
int DayOfWeek (long julianDay);
void DaysOfWeek (int initweek, int weeknumber, int month, int year, TMatWeek MatWeek);
int NumberOfWeek (long julianDay);
bool IsLeapYear (int year);
int DaysOfMonth (int amonth, int ayear);
long GregorianToJulian (int day, int month, int year);
void JulianToGregorian (long julianDay, int& day, int& month, int& year);
time_t makeUnixDate (int day, int month, int year);
const char *getLongMonth (int amonth);
const char *getShortMonth (int amonth);
const char *getLongDay (int aday);
const char *getShortDay2 (int aday);    
const char *getShortDay3 (int aday);        
                                                           
#endif
